<?php
/*************************************************************************************/
/*                                                                                   */
/*      Module Zfhistorique os-commerce  pour Thelia                                   */
/*                                                                                   */
/*      Copyright (c) ZEOS-FRANCE                                                    */
/*      email : contact@zeos-france.fr                                               */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
require_once(realpath(dirname(__FILE__)) . "/config.php");

class Zfhistoriqueoscommerce extends PluginsClassiques{

/* param: DBinfos_loaded - boolean */
var $isDBinfos_loaded = 0; 

	function Zfhistoriqueoscommerce(){
		$this->PluginsClassiques();
		$this->loadDBinfos();
	}

	function init(){
	}

	function destroy(){
	}

	function loadDBinfos() {
		if(defined("CONST_osCommerce_Host") 
		&& defined("CONST_osCommerce_User") 
		&& defined("CONST_osCommerce_pwd") 
		&& defined("CONST_osCommerce_DB") ) {
			$this->isDBinfos_loaded = 1;
		}else{
			$this->isDBinfos_loaded = 0;
		};
	}

	/* 
	getorders
	recup de la liste des commandes-clients dont le no client = $refid
	refid est le code client de THELIA qui est identique à celui de Os-Commerce (customers_id)
	*/
	function getorders($refid){
		$refid = trim($refid);

		if($refid=="") {
			return array();
		}
	
		//ne pas resortir les colonnes car certaines colonnes n'existent dans certaines versions os-commerce ...
		$sSQL = "SELECT * FROM orders left join orders_status on orders_status_id = orders_status  WHERE customers_id='".$refid."'";

		//limiter aux 50 dernieres commandes
		$sSQL.=" order by date_purchased desc ";
		$sSQL.=" limit 0,50 ";	

		//selection de la base de donnees os-commerce
		$dblink = @mysql_connect(CONST_osCommerce_Host, CONST_osCommerce_User, CONST_osCommerce_pwd)
		    or die("Impossible de se connecter au serveur de la base Os-Commerce: " . mysql_error());
		//echo 'Connexion réussie';

		mysql_select_db(CONST_osCommerce_DB,$dblink)
			or die("Impossible de selectionner la base : ".CONST_osCommerce_DB);
	
		$result = mysql_query($sSQL, $dblink) 
			or die("Impossible de requeter la base : ".mysql_errno($dblink)." - ".mysql_error());

		$tabresult = array();
	 	if(mysql_num_rows($result)>0) {

			while ($row = mysql_fetch_array($result)) {
			   	
				$status = $row["orders_status_name"];
				list($year, $month, $day) = explode("-", substr($row["date_purchased"],0, 10));
				$time = substr($row["date_purchased"], 11, 8);
				$date_commande = $day."/".$month."/".$year." ".$time;

				$tabtotal = $this->getOrderTotal($row["orders_id"]); 
			   	$ttc_amount = number_format($tabtotal["ot_total"]["amount"], 2);

			   	$tabresult[] = array( "nom_commande" =>$row["customers_name"], 
						"num_commande" => $row["orders_id"],
						"date_commande" => $date_commande, 
						"montant_commande" =>$ttc_amount,
						"statut_commande" => $status
						);
			}
		}

		//liberer le bouzin
		mysql_free_result($result);

		//fermer la connexion, SVP
		//mysql_close($dblink);

		return $tabresult;
	}

	/* 
	function getorderdetail
	recup de la liste des commandes-clients dont le no client = $refid et orderid = $orderid
	refid est le code client de THELIA qui est identique à celui de Os-Commerce (customers_id)
	*/
	
	function getorderdetail($refid, $orderid){
		$orderid = trim($orderid);
		$refid = trim($refid);

		if($refid=="" || $orderid=="") {
			return array();
		}

		//ne pas resortir les colonnes car certaines colonnes n'existent dans certaines versions os-commerce ...
		$sSQL = "SELECT * FROM orders left join orders_status on orders_status_id = orders_status  WHERE orders_id='".$orderid."' AND customers_id='".$refid."'";

		//limiter a une ligne
		$sSQL.=" order by date_purchased desc ";
		$sSQL.=" limit 0,1 ";	

		//selection de la base de donnees os-commerce
		$dblink = @mysql_connect(CONST_osCommerce_Host, CONST_osCommerce_User, CONST_osCommerce_pwd)
		    or die("Impossible de se connecter au serveur de la base Os-Commerce: " . mysql_error());
		//echo 'Connexion réussie';

		mysql_select_db(CONST_osCommerce_DB,$dblink)
			or die("Impossible de selectionner la base : ".CONST_osCommerce_DB);
	
		$result = mysql_query($sSQL, $dblink) 
			or die("Impossible de requeter la base : ".mysql_errno($dblink)." - ".mysql_error());

		$tabresult = array();
	 	if(mysql_num_rows($result)>0) {

			while ($row = mysql_fetch_array($result)) {
				$tabtotal = $this->getOrderTotal($row["orders_id"]); 
			   	$ttc_amount = number_format( $tabtotal["ot_total"]["amount"], 2);
			   	$montant_soustotal = number_format($tabtotal["ot_subtotal"]["amount"], 2);
			   	$montant_total_livraison = number_format($tabtotal["ot_shipping"]["amount"], 2);
			   	$montant_total_tva = number_format($tabtotal["ot_tax"]["amount"], 2);

				$status = $row["orders_status_name"];

				list($year, $month, $day) = explode("-", substr($row["date_purchased"],0, 10));
				$time = substr($row["date_purchased"], 11, 8);
				$date_commande = $day."/".$month."/".$year." ".$time;

				list($year, $month, $day) = explode("-", substr($row["last_modified"],0, 10));
				$time = substr($row["last_modified"], 11, 8);
				$date_maj = $day."/".$month."/".$year." ".$time;
			

			   	$tabresult[] = array( "nom_commande" =>$row["customers_name"], 
						"num_commande" => $row["orders_id"],
						"date_commande" => $date_commande, 
						"montant_commande" =>$ttc_amount,
						"montant_soustotal" =>$montant_soustotal,
						"montant_total_livraison" => $montant_total_livraison ,
						"montant_total_tva" => $montant_total_tva,

						"statut_commande" => $status,
						"date_maj" => $date_maj,

						"email" => $row["customers_email_address"],
						"type_paiement" => $row["payment_method"],
						"facturation_nom" => $row["billing_name"],
						"facturation_adresse1" => $row["billing_street_address"],
						"facturation_adresse2" => $row["billing_suburb"],
						"facturation_ville" => $row["billing_city"],
						"facturation_codepostal" => $row["billing_postcode"],
						"facturation_pays" => $row["billing_country"],
						"livraison_nom" => $row["delivery_name"],
						"livraison_adresse1" => $row["delivery_street_address"],
						"livraison_adresse2" => $row["delivery_suburb"],
						"livraison_ville" => $row["delivery_city"],
						"livraison_codepostal" => $row["delivery_postcode"],
						"livraison_pays" => $row["delivery_country"],

						);
			}
		}

		//liberer le bouzin
		mysql_free_result($result);

		//fermer la connexion, SVP
		mysql_close($dblink);

		return $tabresult;
	}


	/*
	getOrderTotal: recuperation des totaux d'une commande
	*/

	function getOrderTotal($orderid) {
		$tabresult= array();
		$sSQL='SELECT orders_total_id, title, text, value, class  from orders_total where orders_id='.$orderid;

		//selection de la base de donnees os-commerce
		$dblink = @mysql_connect(CONST_osCommerce_Host, CONST_osCommerce_User, CONST_osCommerce_pwd)
		    or die("Impossible de se connecter au serveur de la base Os-Commerce: " . mysql_error());
		//echo 'Connexion réussie';

		mysql_select_db(CONST_osCommerce_DB,$dblink)
			or die("Impossible de selectionner la base : ".CONST_osCommerce_DB);
	
		$result = mysql_query($sSQL, $dblink) 
			or die("Impossible de requeter la base : ".mysql_errno($dblink)." - ".mysql_error());

		$tabresult = array();
	 	if(mysql_num_rows($result)>0) {

			while ($row = mysql_fetch_array($result)) {
				$tabresult[$row["class"]]= array(
					"lineid" => $row["orders_total_id"], 
					"titre" =>$row["title"], 
					"html" =>$row["text"], 
					"amount" => $row["value"]					
				);
			} //wend

		} //if num_rows


		return $tabresult;

	}


	/*
	getOrderLines  : liste des produits commandés
	*/
	function getOrderLines($orderid) {
		$orderid = trim($orderid);
		$tabresult = array();

		$sSQL = "SELECT products_id, products_model, products_name, products_price, final_price, products_tax, products_quantity  FROM orders_products WHERE orders_id=".$orderid;
		//selection de la base de donnees os-commerce
		$dblink = @mysql_connect(CONST_osCommerce_Host, CONST_osCommerce_User, CONST_osCommerce_pwd)
		    or die("Impossible de se connecter au serveur de la base Os-Commerce: " . mysql_error());
		//echo 'Connexion réussie';

		mysql_select_db(CONST_osCommerce_DB,$dblink)
			or die("Impossible de selectionner la base : ".CONST_osCommerce_DB);
	
		$result = mysql_query($sSQL, $dblink) 
			or die("Impossible de requeter la base : ".mysql_errno($dblink)." - ".mysql_error());

		$tabresult = array();
	 	if(mysql_num_rows($result)>0) {

			while ($row = mysql_fetch_array($result)) {
				$tabresult[]= array(
					"id" => $row["products_id"], 
					"ref_produit" =>$row["products_model"], 
					"libelle_produit" =>$row["products_name"], 
					"prix_ht" => number_format( $row["products_price"], 2) , 
					"qte" =>$row["products_quantity"], 
					"prix_ttc" =>number_format($row["final_price"]*(1+$row["products_tax"]*0.01), 2)				
					);
			} //wend

		} //if num_rows


		return $tabresult;
	}

}


?>
